def to_str(n, base):
  """ Vrať 'n' jako řetězec v číselné soustavě se základem 'base' """
  assert(n>=0)
  cislice = "0123456789ABCDEF"
  print("Zacatek rekurze",n, cislice[n % base])
  if n < base:
    print("Specialni konec",n, cislice[n])
    return cislice[n]
  v= to_str(n // base, base) + cislice[n % base]
  print("Konec rekurze",n,"vysledek",v)
  return v

print(to_str(2016,16))
print(to_str(5,2))

def to_str_nonrecursive(n,base):
  assert(n>=0)
  cislice = "0123456789ABCDEF"
  stack=[n] # hodnoty n
  n//=base
  while n>0:
    stack.append(n)
    n//=base
  print("Nerekurzivne, hodnota zasobniku",*stack)
  result=""
  for m in range(len(stack)-1,-1,-1):
    result+=cislice[stack[m] % base]
  return result

print(to_str_nonrecursive(2016,16))
print(to_str_nonrecursive(5,2))


def to_str_nonrecursive2(n,base):
  assert(n>=0)
  cislice="0123456789ABCDEF"
  result=""
  while n>0:
    result=cislice[n % base]+result
    print("Nerekurzivne, pridavam vlevo",result)
    n//=base
  return result

print(to_str_nonrecursive2(2016,16))
print(to_str_nonrecursive2(5,2))

