def quick_sort(a):
  """ Setřídí pole a na místě """
  quick_sort_helper(a,0,len(a)-1)

def quick_sort_helper(a,first,last):
  """ setřídí podpole a[first]..a[last] """ 
  if first < last:
      m = partition(a,first,last)
      print("Cast",a[first:m], a[m], a[m+1:last+1])
      quick_sort_helper(a,first,m-1)
      quick_sort_helper(a,m+1,last)

def partition(a,first,right):
  """ Vrátí index 'i' a změní 'a' tak, že všechny prvky před 'i' jsou menší než a[i] a všechny prvky po 'i' jsou větší než a[i]"""
  pivot=a[first]
  left=first+1
  while left<=right: # najdi první zleva větší než pivot
    while left<=right and a[left] <= pivot:
      left+=1
    while left<=right and a[right] >= pivot:
      right-=1
    if right<left:
      a[first],a[right]=a[right],a[first]  # pivot na místo
    else:
      a[left],a[right]=a[right],a[left] # výměna
  return right
  
def main():
    a=[521, 842, 124, 948, 354, 101, 706, 475, 356, 16]
    quick_sort(a)
    print(a)

if __name__=="__main__":
  main()    
    
