def num_digits(a):
  """ počet číslic v desítkovém zápisu čísla a """
  num=1
  while a>10:
    a//=10
    num+=1
  return num

def digit(a,n):
  """ n-tá číslice zprava čísla 'a', počítáno od nuly"""
  return a//(10**n) % 10

def radix_sort_integers(a):
  """ setřídí pole přirozených čísel s omezeným počtem číslic """
  max_digits=num_digits(max(a)) # max. počet číslic
  for i in range(max_digits):
    a=sort_by_digit(a,i)
    print(a)
  return a

def sort_by_digit(a,i):
  """ setřídí pole 'a' dle i-té číslice """  
  prihradka=[ [] for j in range(10) ]
  for x in a:
    c=digit(x,i) # číslice pro třídění
    prihradka[c]+=[x]
  r=[]
  for p in prihradka:
    r+=p
  return r  

def main():  
    a=[97531, 15, 13579, 13578, 258, 3689, 23589, 36842, 84653, 74564]
    print(radix_sort_integers(a))

if __name__=="__main__":
  main()    
    
 
