def merge_sort(a):
  """ Setřídí pole a pomocí merge sort """
  print("Zacatek rekurze",a);
  if len(a)<=1:   # triviální případ
    return a 
  mid=len(a)//2   # rozdělení pole na dvě
  left=merge_sort(a[:mid])
  right=merge_sort(a[mid:])
  v= join_arrays(left,right)
  print("Konec rekurze",left,right,"vysledek",v);
  return v

def join_arrays(left,right):
  """ Dvě vzestupně setříděná pole spojí do jednoho """
  result=[] # spojení dvou setříděných polí
  i=0       # index do 'left'
  j=0       # index do 'right'
  while i<len(left) and j<len(right):
    if left[i]<right[j]:
      result+=[left[i]]
      i+=1
    else:
      result+=[right[j]]
      j+=1
  result+=left[i:]    # doplnit zbytky
  result+=right[j:]    
  return result

import random
def main():  
  print("merge sort")
  a=[random.randrange(100) for i in range(10)]
  print(merge_sort(a))

if __name__=="__main__":
  main()    
